; MtApPack = Menuet Applications Packer
; Kolibri version
; Written by diamond in 2006 specially for KolibriOS

; Based on aPLib compression library by Joergen Ibsen
; (for more information on aPLib visit http://www.ibsensoftware.com)

	.486
	.model flat
extrn _aP_workmem_size:proc
extrn _aP_max_packed_size:proc
extrn _aP_pack:proc
.data
	db	'MENUET01'
	dd	1
	dd	offset _start
	dd	offset bss_start	; i_end
memf	dd	offset bss_end		; memory
	dd	offset bss_end		; esp
	dd	offset params		; params
	dd	0		; icon

caption_str	db	'MtApPack'
caption_len	=	$ - caption_str
buttons1names	db	' InFile:'
		db	'OutFile:'
		db	'   Path:'
aStart		db	'START'
aStart_len	=	$ - aStart
bForceMemIncButton_str db 'Force memory size increasing, zero uninit data'
bForceMemIncButton_len = $ - bForceMemIncButton_str
definoutname	db	0
defpath		db	'/RD/1/',0
curedit		dd	0

info_str	db	'MtApPack - Menuet Applications Packer, version 0.2',10
		db	'Based on aPLib v0.43 compression library',10,10
info_len	=	$ - offset info_str
usage_str	db	'Written by diamond in 2006 specially for KolibriOS',10
		db	'aPLib is copyright (c) 1998-2005 by Joergen Ibsen',10
		db	10
		db	'Command-line usage:',10
		db	' mtappack [-0] infile [outfile]',10
		db	'-0: force memory size increasing; use this option,',10
		db	'    if uninitialized app data must be zeroed',10
		db	'    (as does system loader)',10
		db	'    FASM must be packed with this option,',10
		db	"    but most programs don't require it.",10
		db	'If no output file is specified,',10
		db	' packed data will be written back to input file',10
		db	10
		db	'Window usage:',10
		db	" enter input file name, output file name",10
		db	" and press 'Start' button",10
usage_len	=	$ - usage_str
errload_str	db	'Cannot load input file',10
errload_len	=	$ - offset errload_str
outfileerr_str	db	'Cannot save output file',10
outfileerr_len	=	$ - offset outfileerr_str
nomem_str	db	'No memory',10
nomem_len	=	$ - offset nomem_str
not_exe_str	db	'Not Menuet/Kolibri executable!',10
not_exe_len	=	$ - offset not_exe_str
param_or_icon_str db	'This executable uses executable path.',10
		db	'Sorry, this isn''t supported yet.',10
param_or_icon_len =	$ - offset param_or_icon_str
too_big_str	db	'Cannot compress file, output is greater than input.',10
too_big_len	=	$ - too_big_str
stack_err_str	db	'Stack location is too low.',10
		db	'Sorry, rebasing stack isn''t supported yet.',10
stack_err_len	=	$ - stack_err_str
icon_wrn_str	db	"Warning: 'full path' field in header seems to be ",10
		db	" invalid and will be ignored.",10
icon_wrn_len	=	$ - icon_wrn_str
calltrick_err_str db	'Calltrick error',10
calltrick_err_len =	$ - calltrick_err_str

done_str	db	'Packing successful! Compression ratio: '
ratio		dw	'00'
		db	'%',13,10,13,10
done_len	=	$ - done_str

loader	dd	165	; size
	dd	8Dh	; entry
	dd	offset loader_data
loader_less_7D00 dd 158	; size
	dd	86h	; entry
	dd	offset loader_less_7D00_data
loader_less_500 dd 153	; size
	dd	81h	; entry
	dd	offset loader_less_500_data
loader_params dd 184+1
	dd	9Eh
	dd	offset loader_params_data
loader_less_7D00_params dd 177+1
	dd	97h
	dd	offset loader_less_7D00_params_data
loader_less_500_params dd 172+1
	dd	92h
	dd	offset loader_less_500_params_data
loader_data label byte
	db	 5Eh, 6Ah, 34h, 5Fh,0B2h, 80h,0A4h,0B6h, 80h,0FFh, 13h, 73h,0F9h,0FFh, 13h, 73h
	db	 17h, 31h,0C0h,0FFh, 13h, 73h, 20h,0B6h, 80h, 41h,0B0h, 10h,0FFh, 13h, 10h,0C0h
	db	 73h,0FAh, 75h, 3Eh,0AAh, 49h,0EBh,0E1h,0FFh, 53h,0FCh, 00h,0F6h, 83h,0D9h, 01h
	db	 75h, 0Eh,0FFh, 53h,0FCh,0EBh, 27h,0ACh,0D1h,0E8h, 74h, 30h, 11h,0C9h,0EBh, 1Bh
	db	 91h, 48h,0C1h,0E0h, 08h,0ACh,0FFh, 53h,0FCh, 3Dh, 00h, 7Dh, 00h, 00h, 73h, 0Bh
	db	 80h,0FCh, 05h, 73h, 07h, 66h, 83h,0F8h, 7Fh, 77h, 02h, 41h, 41h, 95h, 89h,0E8h
	db	0B6h, 00h, 56h, 89h,0FEh, 29h,0C6h,0F3h,0A4h, 5Eh,0EBh, 9Dh,0FFh, 61h, 0Ch, 00h
	db	0D2h, 75h, 05h, 8Ah, 16h, 46h, 10h,0D2h,0C3h, 31h,0C9h, 41h,0FFh, 13h, 11h,0C9h
	db	0FFh, 13h, 72h,0F8h,0C3h, 79h, 00h, 00h, 00h, 6Fh, 00h, 00h, 00h, 6Ah, 24h, 5Eh
	db	0BFh, 50h, 41h, 52h, 31h, 57h,0B9h, 50h, 41h, 52h, 32h,0F3h,0A4h, 8Dh, 5Fh,0FCh
	db	0E9h, 50h, 41h, 52h, 33h
loader_par1 = 4
loader_par2 = 0Ah
loader_par3_no_params = 14h
loader_par3_ok_params = 16h
loader_par5 = -24h
loader_par6 = 11h
loader_less_7D00_data label byte
; data
	db	 5Eh, 6Ah, 34h, 5Fh,0B2h, 80h,0A4h,0B6h, 80h,0FFh, 13h, 73h,0F9h,0FFh, 13h, 73h
	db	 17h, 31h,0C0h,0FFh, 13h, 73h, 20h,0B6h, 80h, 41h,0B0h, 10h,0FFh, 13h, 10h,0C0h
	db	 73h,0FAh, 75h, 37h,0AAh, 49h,0EBh,0E1h,0FFh, 53h,0FCh, 00h,0F6h, 83h,0D9h, 01h
	db	 75h, 0Eh,0FFh, 53h,0FCh,0EBh, 20h,0ACh,0D1h,0E8h, 74h, 29h, 11h,0C9h,0EBh, 14h
	db	 91h, 48h,0C1h,0E0h, 08h,0ACh,0FFh, 53h,0FCh, 80h,0FCh, 05h, 73h, 07h, 66h, 83h
	db	0F8h, 7Fh, 77h, 02h, 41h, 41h, 95h, 89h,0E8h,0B6h, 00h, 56h, 89h,0FEh, 29h,0C6h
	db	0F3h,0A4h, 5Eh,0EBh,0A4h,0FFh, 61h, 0Ch, 00h,0D2h, 75h, 05h, 8Ah, 16h, 46h, 10h
	db	0D2h,0C3h, 31h,0C9h, 41h,0FFh, 13h, 11h,0C9h,0FFh, 13h, 72h,0F8h,0C3h, 72h, 00h
	db	 00h, 00h, 68h, 00h, 00h, 00h, 6Ah, 24h, 5Eh,0BFh, 50h, 41h, 52h, 31h, 57h,0B9h
	db	 50h, 41h, 52h, 32h,0F3h,0A4h, 8Dh, 5Fh,0FCh,0E9h, 50h, 41h, 52h, 33h
loader_less_500_data label byte
; data
	db	 5Eh, 6Ah, 34h, 5Fh,0B2h, 80h,0A4h,0B6h, 80h,0FFh, 13h, 73h,0F9h,0FFh, 13h, 73h
	db	 17h, 31h,0C0h,0FFh, 13h, 73h, 20h,0B6h, 80h, 41h,0B0h, 10h,0FFh, 13h, 10h,0C0h
	db	 73h,0FAh, 75h, 32h,0AAh, 49h,0EBh,0E1h,0FFh, 53h,0FCh, 00h,0F6h, 83h,0D9h, 01h
	db	 75h, 0Eh,0FFh, 53h,0FCh,0EBh, 1Bh,0ACh,0D1h,0E8h, 74h, 24h, 11h,0C9h,0EBh, 0Fh
	db	 91h, 48h,0C1h,0E0h, 08h,0ACh,0FFh, 53h,0FCh, 66h, 83h,0F8h, 7Fh, 77h, 02h, 41h
	db	 41h, 95h, 89h,0E8h,0B6h, 00h, 56h, 89h,0FEh, 29h,0C6h,0F3h,0A4h, 5Eh,0EBh,0A9h
	db	0FFh, 61h, 0Ch, 00h,0D2h, 75h, 05h, 8Ah, 16h, 46h, 10h,0D2h,0C3h, 31h,0C9h, 41h
	db	0FFh, 13h, 11h,0C9h,0FFh, 13h, 72h,0F8h,0C3h, 6Dh, 00h, 00h, 00h, 63h, 00h, 00h
	db	 00h, 6Ah, 24h, 5Eh,0BFh, 50h, 41h, 52h, 31h, 57h,0B9h, 50h, 41h, 52h, 32h,0F3h
	db	0A4h, 8Dh, 5Fh,0FCh,0E9h, 50h, 41h, 52h, 33h
loader_params_data label byte
	db	 5Eh, 57h, 6Ah, 34h, 5Fh,0B2h, 80h,0A4h,0B6h, 80h,0FFh, 13h, 73h,0F9h,0FFh, 13h
	db	 73h, 17h, 31h,0C0h,0FFh, 13h, 73h, 20h,0B6h, 80h, 41h,0B0h, 10h,0FFh, 13h, 10h
	db	0C0h, 73h,0FAh, 75h, 3Eh,0AAh, 49h,0EBh,0E1h,0FFh, 53h,0FCh, 00h,0F6h, 83h,0D9h
	db	 01h, 75h, 0Eh,0FFh, 53h,0FCh,0EBh, 27h,0ACh,0D1h,0E8h, 74h, 30h, 11h,0C9h,0EBh
	db	 1Bh, 91h, 48h,0C1h,0E0h, 08h,0ACh,0FFh, 53h,0FCh, 3Dh, 00h, 7Dh, 00h, 00h, 73h
	db	 0Bh, 80h,0FCh, 05h, 73h, 07h, 66h, 83h,0F8h, 7Fh, 77h, 02h, 41h, 41h, 95h, 89h
	db	0E8h,0B6h, 00h, 56h, 89h,0FEh, 29h,0C6h,0F3h,0A4h, 5Eh,0EBh, 9Dh, 5Fh,0B5h, 01h
	db	 29h,0CFh, 89h,0FEh,0F2h,0AEh,0F6h,0D9h, 8Bh, 78h, 1Ch,0F3h,0A4h,0FFh, 60h, 0Ch
	db	 00h,0D2h, 75h, 05h, 8Ah, 16h, 46h, 10h,0D2h,0C3h, 31h,0C9h, 41h,0FFh, 13h, 11h
	db	0C9h,0FFh, 13h, 72h,0F8h,0C3h, 8Ah, 00h, 00h, 00h, 80h, 00h, 00h, 00h, 6Ah, 24h
	db	 5Eh,0BFh, 50h, 41h, 52h, 31h, 57h,0B9h, 50h, 41h, 52h, 32h,0F3h,0A4h,0BBh, 50h
	db	 41h, 52h, 36h,0E9h, 50h, 41h, 52h, 33h
	db	0
loader_less_7D00_params_data label byte
	db	 5Eh, 57h, 6Ah, 34h, 5Fh,0B2h, 80h,0A4h,0B6h, 80h,0FFh, 13h, 73h,0F9h,0FFh, 13h
	db	 73h, 17h, 31h,0C0h,0FFh, 13h, 73h, 20h,0B6h, 80h, 41h,0B0h, 10h,0FFh, 13h, 10h
	db	0C0h, 73h,0FAh, 75h, 37h,0AAh, 49h,0EBh,0E1h,0FFh, 53h,0FCh, 00h,0F6h, 83h,0D9h
	db	 01h, 75h, 0Eh,0FFh, 53h,0FCh,0EBh, 20h,0ACh,0D1h,0E8h, 74h, 29h, 11h,0C9h,0EBh
	db	 14h, 91h, 48h,0C1h,0E0h, 08h,0ACh,0FFh, 53h,0FCh, 80h,0FCh, 05h, 73h, 07h, 66h
	db	 83h,0F8h, 7Fh, 77h, 02h, 41h, 41h, 95h, 89h,0E8h,0B6h, 00h, 56h, 89h,0FEh, 29h
	db	0C6h,0F3h,0A4h, 5Eh,0EBh,0A4h, 5Fh,0B5h, 01h, 29h,0CFh, 89h,0FEh,0F2h,0AEh,0F6h
	db	0D9h, 8Bh, 78h, 1Ch,0F3h,0A4h,0FFh, 60h, 0Ch, 00h,0D2h, 75h, 05h, 8Ah, 16h, 46h
	db	 10h,0D2h,0C3h, 31h,0C9h, 41h,0FFh, 13h, 11h,0C9h,0FFh, 13h, 72h,0F8h,0C3h, 83h
	db	 00h, 00h, 00h, 79h, 00h, 00h, 00h, 6Ah, 24h, 5Eh,0BFh, 50h, 41h, 52h, 31h, 57h
	db	0B9h, 50h, 41h, 52h, 32h,0F3h,0A4h,0BBh, 50h, 41h, 52h, 36h,0E9h, 50h, 41h, 52h
	db	 33h
	db	0
loader_less_500_params_data label byte
	db	 5Eh, 57h, 6Ah, 34h, 5Fh,0B2h, 80h,0A4h,0B6h, 80h,0FFh, 13h, 73h,0F9h,0FFh, 13h
	db	 73h, 17h, 31h,0C0h,0FFh, 13h, 73h, 20h,0B6h, 80h, 41h,0B0h, 10h,0FFh, 13h, 10h
	db	0C0h, 73h,0FAh, 75h, 32h,0AAh, 49h,0EBh,0E1h,0FFh, 53h,0FCh, 00h,0F6h, 83h,0D9h
	db	 01h, 75h, 0Eh,0FFh, 53h,0FCh,0EBh, 1Bh,0ACh,0D1h,0E8h, 74h, 24h, 11h,0C9h,0EBh
	db	 0Fh, 91h, 48h,0C1h,0E0h, 08h,0ACh,0FFh, 53h,0FCh, 66h, 83h,0F8h, 7Fh, 77h, 02h
	db	 41h, 41h, 95h, 89h,0E8h,0B6h, 00h, 56h, 89h,0FEh, 29h,0C6h,0F3h,0A4h, 5Eh,0EBh
	db	0A9h, 5Fh,0B5h, 01h, 29h,0CFh, 89h,0FEh,0F2h,0AEh,0F6h,0D9h, 8Bh, 78h, 1Ch,0F3h
	db	0A4h,0FFh, 60h, 0Ch, 00h,0D2h, 75h, 05h, 8Ah, 16h, 46h, 10h,0D2h,0C3h, 31h,0C9h
	db	 41h,0FFh, 13h, 11h,0C9h,0FFh, 13h, 72h,0F8h,0C3h, 7Eh, 00h, 00h, 00h, 74h, 00h
	db	 00h, 00h, 6Ah, 24h, 5Eh,0BFh, 50h, 41h, 52h, 31h, 57h,0B9h, 50h, 41h, 52h, 32h
	db	0F3h,0A4h,0BBh, 50h, 41h, 52h, 36h,0E9h, 50h, 41h, 52h, 33h
	db	0

calltrick db	0B9h, 43h, 54h, 52h, 31h, 96h,0ACh, 2Ch,0E8h, 3Ch, 01h, 77h,0F9h, 80h, 3Eh, 78h
	db	 75h,0F4h,0ADh,0C1h,0E8h, 08h, 29h,0F0h, 89h, 46h,0FCh,0E2h,0E9h, 31h,0C0h
calltrick_size = $ - calltrick

useCalltrick	db	0
bForceMemInc	db	0

.data?
bss_start label byte

params	db	256 dup (?)

color_table dd	10 dup (?)
skinheight dd	?

innamelen dd	?
inname	db	32 dup (?)
outnamelen dd	?
outname	db	32 dup (?)
pathlen dd	?
path	db	32 dup (?)

curedit_y	dd	?

message_mem	db	64*20 dup (?)
message_cur_pos	dd	?

insize		dd	?
outsize		dd	?
infile		dd	?
outfile		dd	?
inbuftmp	dd	?
outbuftmp	dd	?
workmem		dd	?
app_i_param	dd	?
app_i_icon	dd	?
cur_loader_size dd	?
cur_loader_entry dd	?
cur_loader	db	256 dup (?)
indelta		dd	?
ct1		db	256 dup (?)
ctn		dd	?
cti		db	?

fn58block label byte
fn58op	dd	?
fn58start dd	?
fn58size dd	?
fn58dest dd	?
fn58osmem dd	?
fullname db	80 dup (?)

init_data db	512 dup (?)

osmem	db	4096 dup (?)

mtstack	db	200h dup (?)
bss_end label byte

.code

clear_messages:
	xor	eax, eax
	mov	ecx, 64*20/4+1
	mov	edi, offset message_mem
	rep	stosd
	ret

_start:
	call	clear_messages
; get system window info
	mov	al, 48
	push	3
	pop	ebx
	mov	ecx, offset color_table
	push	40
	pop	edx
	int	40h
	inc	ebx
	int	40h
	mov	[skinheight], eax
; check command line
	mov	esi, offset params
	mov	byte ptr [esi+100h], 0
	call	skip_spaces
	cmp	al, '-'
	jnz	short not_opt
	lodsb
	lodsb
	cmp	al, '0'
	jnz	short default
	mov	[bForceMemInc], 1
	call	skip_spaces
not_opt:
	test	al, al
	jz	short default
	mov	edi, offset inname
	call	copy_name
	test	al, al
	jz	short outeqin
	mov	edi, offset outname
	call	copy_name
	test	al, al
	jnz	short default
doit:
	and	[pathlen], 0
	call	draw_window
	call	pack
	jmp	waitevent
exit:
	xor	eax, eax
	dec	eax
	int	40h
outeqin:
	mov	ecx, 32/4+1
	mov	esi, offset inname-4
	mov	edi, offset outname-4
	rep	movsd
	jmp	short doit
default:
	mov	[curedit], offset inname
	mov	ecx, [skinheight]
	add	ecx, 5
	mov	[curedit_y], ecx
	mov	esi, offset definoutname
	mov	edi, esi
	xor	ecx, ecx
	xor	eax, eax
	dec	ecx
	repnz	scasb
	not	ecx
	dec	ecx
	mov	[innamelen], ecx
	push	ecx
	push	esi
	mov	edi, offset inname
	rep	movsb
	pop	esi
	pop	ecx
	mov	[outnamelen], ecx
	mov	edi, offset outname
	rep	movsb
	mov	esi, offset defpath
	mov	edi, esi
	xor	ecx, ecx
	dec	ecx
	repnz	scasb
	not	ecx
	dec	ecx
	mov	[pathlen], ecx
	mov	edi, offset path
	rep	movsb
dodraw:
	call	draw_window
waitevent:
	push	10
	pop	eax
	int	40h
	dec	eax
	jz	short dodraw
	dec	eax
	jz	keypressed
	dec	eax
	jnz	short waitevent
; button pressed
	mov	al, 17
	int	40h
	xchg	al, ah
	cmp	al, 6
	jz	short but6
	cmp	al, 7
	jz	short but7
	dec	eax
	jz	exit
	dec	eax
	jnz	short nopack
	call	pack
	jmp	short waitevent
but6:
	xor	[bForceMemInc], 1
	call	redraw_bForceMemInc
	jmp	short waitevent
but7:
	call	clear_messages
; display logo
	mov	esi, offset info_str
	push	info_len
	pop	ecx
	call	write_string
; display info
	mov	esi, offset usage_str
	mov	ecx, usage_len
	call	write_string
	jmp	short waitevent
nopack:
; this is infile/outfile/path button
	call	clear_edit_points
	mov	esi, offset inname
	mov	ecx, [skinheight]
	add	ecx, 5
	dec	eax
	jz	short edit
	mov	esi, offset outname
	add	ecx, 0Ch
	dec	eax
	jz	short edit
	mov	esi, offset path
	add	ecx, 0Ch
edit:
	cmp	esi, [curedit]
	mov	[curedit], 0
	jz	waitevent
	mov	[curedit], esi
	mov	[curedit_y], ecx
	mov	al, 1
	mov	ebx, [esi-4]
	mov	edi, ebx
	imul	ebx, 6
	add	ebx, 42h
	add	ecx, 4
	xor	edx, edx
@@:
	cmp	edi, 32
	jz	waitevent
	int	40h
	add	ebx, 6
	inc	edi
	jmp	@b
keypressed:
	mov	al, 2
	int	40h
	xchg	al, ah
	mov	edi, [curedit]
	test	edi, edi
	jz	waitevent
	mov	ebx, [edi-4]
	cmp	al, 8
	jz	short backspace
	cmp	al, 13
	jz	onenter
	cmp	al, 20h
	jb	waitevent
	cmp	ebx, 32
	jz	waitevent
	mov	[edi+ebx], al
	inc	ebx
	mov	[edi-4], ebx
; clear point and draw symbol
	lea	edi, [ebx+edi-1]
	imul	ebx, 6
	add	ebx, 40h-6
	shl	ebx, 16
	mov	al, 13
	mov	bl, 6
	mov	ecx, [curedit_y]
	push	ecx
	shl	ecx, 16
	mov	cl, 9
	mov	edx, [color_table+20]
	int	40h
	pop	ecx
	mov	bx, cx
	mov	edx, edi
	push	1
	pop	esi
	mov	ecx, [color_table+32]
	mov	al, 4
	int	40h
	jmp	waitevent
backspace:
	test	ebx, ebx
	jz	waitevent
	dec	ebx
	mov	[edi-4], ebx
; clear symbol and set point
	imul	ebx, 6
	add	ebx, 40h
	shl	ebx, 16
	mov	al, 13
	mov	bl, 6
	mov	ecx, [curedit_y]
	push	ecx
	shl	ecx, 16
	mov	cl, 9
	mov	edx, [color_table+20]
	int	40h
	xor	edx, edx
	shr	ebx, 16
	inc	ebx
	inc	ebx
	pop	ecx
	add	ecx, 4
	mov	al, 1
	int	40h
	jmp	waitevent
onenter:
	cmp	[curedit], offset inname
	jnz	short @f
	push	2
	pop	eax
	jmp	nopack
@@:	cmp	[curedit], offset outname
	jnz	short @f
	call	pack
	jmp	waitevent
@@:	call	clear_edit_points
	jmp	waitevent

pack:
	call	clear_edit_points
	and	[curedit], 0
; clear messages
	call	clear_messages
; display logo
	mov	esi, offset info_str
	push	info_len
	pop	ecx
	call	write_string
; load input file
	mov	esi, offset inname
	call	get_full_name
	mov	ebx, offset fn58block
	and	dword ptr [ebx], 0
	and	dword ptr [ebx+4], 0
	mov	dword ptr [ebx+8], 1
	mov	dword ptr [ebx+12], offset init_data
	mov	dword ptr [ebx+16], offset osmem
	push	58
	pop	eax
	int	40h
	test	eax, eax
	jz	short inopened
infileerr:
	mov	esi, offset errload_str
	push	errload_len
	pop	ecx
	jmp	write_string
inopened:
; maximum memory requests: 2*insize + 2*(maxoutsize+200h) + worksize
	mov	[insize], ebx
	mov	esi, [memf]
	mov	[infile], esi
	add	esi, ebx
	mov	[inbuftmp], esi
	add	esi, ebx
	mov	[outfile], esi
	push	ebx
	call	_aP_max_packed_size
	add	eax, 200h
	pop	ecx
	add	esi, eax
	mov	[outbuftmp], esi
	add	esi, eax
	mov	[workmem], esi
	add	eax, ebx
	add	eax, eax
	push	eax
	push	ebx
	call	_aP_workmem_size
	pop	ecx
	pop	ecx
	add	ecx, eax
	add	ecx, [memf]
	push	64
	pop	eax
	push	1
	pop	ebx
	int	40h
	test	eax, eax
	jz	short mem_ok
	mov	esi, offset nomem_str
	push	nomem_len
	pop	ecx
	jmp	write_string
mem_ok:
	mov	eax, [insize]
	add	eax, 511
	shr	eax, 9
	mov	ebx, offset fn58block
	mov	[ebx+8], eax
	mov	esi, [infile]
	mov	[ebx+12], esi
	push	58
	pop	eax
	int	40h
	test	eax, eax
	jnz	infileerr
	lodsd
	cmp	eax, 'UNEM'
	jnz	short not_menuet_exe
	lodsd
	bswap	eax
	sub	eax, 'ET00'
	cmp	eax, 1
	jz	short menuet01
	jb	short menuet00
not_menuet_exe:
	mov	esi, offset not_exe_str
	push	not_exe_len
	pop	ecx
	jmp	write_string
menuet01:
	mov	eax, [esi+1Ch-8]
	mov	[app_i_param], eax
	mov	eax, [esi+20h-8]
	mov	[app_i_icon], eax
; some stupid apps (such as 'desktop') begins from offset 0x20 and overwrite app_i_icon
	cmp	eax, [esi+14h-8]
	jb	short ok_sig
	mov	esi, offset icon_wrn_str
	push	icon_wrn_len
	pop	ecx
	call	write_string
	jmp	short zero_icon
menuet00:
	mov	eax, [esi+18h-8]
	mov	[app_i_param], eax
zero_icon:
	and	[app_i_icon], 0
ok_sig:
	cmp	[app_i_icon], 0
	jz	short @f
	push	param_or_icon_len
	pop	ecx
	mov	esi, offset param_or_icon_str
	jmp	write_string
@@:
; for files smaller than 32000 bytes, use small loader
	mov	eax, [insize]
	cmp	eax, 32000
	mov	esi, offset loader
	ja	short @f
	mov	esi, offset loader_less_7D00
	cmp	eax, 500h
	ja	short @f
	mov	esi, offset loader_less_500
; for executables with params use corresponding loader
@@:	cmp	[app_i_param], 0
	jz	short @f
	add	esi, 3*4*3
; set loader
@@:	call	set_cur_loader
	mov	eax, [outfile]
	mov	dword ptr [eax], 'UNEM'
	mov	dword ptr [eax+4], '10TE'
	mov	dword ptr [eax+8], 1
	mov	edi, eax
	mov	ecx, 12
	mov	esi, [infile]
	repz	cmpsb
	jz	@f
	dec	edi
@@:	sub	edi, eax
	mov	eax, edi
	mov	[indelta], eax
	mov	al, [useCalltrick]
	cmp	al, 0
	jz	short tryboth
	cmp	al, 1
	jz	short forcecalltrick
	call	pack_normal
	mov	[outsize], eax
	jmp	pack_common
forcecalltrick:
	call	pack_calltrick
	mov	[outsize], eax
	test	eax, eax
	jnz	short pack_use_calltrick
	push	calltrick_err_len
	mov	esi, offset calltrick_err_str
	pop	ecx
	jmp	write_string
tryboth:
	call	pack_normal
	mov	[outsize], eax
	mov	esi, [outfile]
	push	esi
	mov	edi, [outbuftmp]
	mov	[outfile], edi
	mov	ecx, 12
	rep	movsb
	call	pack_calltrick
	test	eax, eax
	jz	use_normal
	add	eax, calltrick_size
	cmp	eax, [outsize]
	jae	use_normal
	sub	eax, calltrick_size
	mov	[outsize], eax
	pop	ecx
pack_use_calltrick:
; modify loader
	mov	ecx, calltrick_size
	cmp	[ctn], 0FFFFh
	ja	short @f
	dec	ecx
@@:
	cmp	[ctn], 0FFh
	ja	short @f
	dec	ecx
	dec	ecx
@@:
	mov	edx, 31h
	cmp	[app_i_param], 0
	jnz	short @f
	dec	ecx
	dec	ecx
	mov	dl, 21h
@@:
	mov	edi, offset cur_loader + 255
	mov	esi, edi
	sub	esi, ecx
	push	ecx
	mov	ecx, esi
	sub	ecx, offset cur_loader - 1
	add	ecx, edx
	sub	ecx, [cur_loader_entry]
	std
	rep	movsb
	cld
	lea	edi, [esi+1]
	pop	ecx
	add	[cur_loader_entry], ecx
	add	[cur_loader_size], ecx
	mov	esi, offset cur_loader
	add	esi, [cur_loader_entry]
	add	[esi-4], ecx
	add	[esi-8], ecx
	mov	esi, offset calltrick
	mov	dl, [cti]
	mov	[esi+15], dl
	mov	edx, [ctn]
	mov	[esi+1], edx
	cmp	edx, 0FFFFh
	ja	short calltrick_modified
	inc	esi
	cmp	edx, 0FFh
	ja	short @f
	inc	esi
	inc	esi
	mov	byte ptr [esi], 0B1h	; mov cl,<xx>
	mov	[esi+1], dl
	jmp	short calltrick_modified
@@:
	mov	word ptr [esi], 0B966h	; mov cx,<xx>
	mov	[esi+2], dx
calltrick_modified:
	rep	movsb
	jmp	short pack_common
use_normal:
	pop	[outfile]
pack_common:
	add	eax, [cur_loader_size]
	add	eax, 24h
	cmp	eax, [insize]
	jb	short packed_ok
	mov	esi, offset too_big_str
	push	too_big_len
	pop	ecx
	jmp	write_string
packed_ok:
; set header
	mov	edi, [outfile]
	mov	eax, [outsize]
	add	eax, 24h
	push	eax
	add	eax, [cur_loader_entry]
	mov	[edi+12], eax
	pop	eax
	add	eax, [cur_loader_size]
	mov	[edi+16], eax
	mov	edx, [infile]
	mov	ecx, [edx+20]
	mov	[edi+20], ecx
	shr	ecx, 1
	sub	ecx, 10h
	cmp	byte ptr [edx+7], '0'
	jz	short @f
	mov	ecx, [edx+24]
@@:	mov	[edi+24], ecx
	and	dword ptr [edi+28], 0
	cmp	[app_i_param], 0
	jz	short @f
	dec	eax
	mov	[edi+28], eax
@@:
	and	dword ptr [edi+32], 0
; find destination memory
	mov	eax, [outsize]
	add	eax, 24
	push	eax
	add	eax, [cur_loader_entry]
	cmp	[app_i_param], 0
	jz	short @f
	pop	eax
	push	eax
	add	eax, [cur_loader_size]
	add	eax, 255
@@:	pop	ecx
; we need eax bytes of additional memory
; memory map: (inclusive..exclusive)
; 0..[insize] : here will be unpacked output
; esp-10h..esp : stack (note that if it intercepts with 1st region, loader stack must be changed)
; if command line is used: app_i_param..app_i_param+100h : parameters
	mov	ecx, [edi+24]
	sub	ecx, 10h
	mov	edx, [app_i_param]
	add	edx, 100h
	cmp	edx, [insize]
	ja	short @f
	mov	edx, [insize]
@@:	sub	ecx, edx
	jae	short @f
; hmm... probably this is @rcher or similar app, and stack is between main code and params?
	add	ecx, edx
	cmp	ecx, [insize]
	jb	short stack_err
	mov	ecx, [edi+24]
	cmp	ecx, [app_i_param]
	jbe	short place_mem_test
stack_err:
	push	stack_err_len
	mov	esi, offset stack_err_str
	pop	ecx
	jmp	write_string
@@:
	cmp	[bForceMemInc], 0
	jz	short @f
	mov	edx, [edi+20]
	jmp	short place_mem_test
@@:
	cmp	ecx, eax
	jae	short place_found
; if no place between (file+parameters) and stack, then use high location - after stack
	mov	edx, [edi+24]
; probably we need to increase memory size?
place_mem_test:
	lea	ecx, [eax+edx]
	cmp	ecx, [edi+20]
	jbe	short place_found
	mov	[edi+20], ecx
place_found:
; edx contains additional place

; setup loader
	mov	esi, offset cur_loader
	mov	al, byte ptr [indelta]
	cmp	[app_i_param], 0
	jnz	short setup_params
	mov	[esi+2], al
	add	esi, [cur_loader_entry]
	mov	[esi+loader_par1], edx
	mov	ecx, [outsize]
	add	ecx, [cur_loader_entry]
	mov	[esi+loader_par2], ecx
	mov	ecx, edx
	sub	ecx, [cur_loader_size]
	sub	ecx, 24h
	mov	[esi+loader_par3_no_params], ecx
	jmp	short setup_common
setup_params:
	mov	[esi+3], al
	add	esi, [cur_loader_entry]
	mov	[esi+loader_par1], edx
	mov	ecx, [outsize]
	add	ecx, [cur_loader_size]
	add	ecx, 255
	mov	[esi+loader_par2], ecx
	lea	ecx, [edx-4]
	add	ecx, [outsize]
	add	ecx, [cur_loader_entry]
	mov	[esi+loader_par6], ecx
	mov	ecx, [infile]
	cmp	byte ptr [ecx+7], '0'
	jnz	short @f
	mov	byte ptr [esi+loader_par5], 18h
@@:
	mov	ecx, edx
	sub	ecx, [cur_loader_size]
	sub	ecx, 24h-1
	mov	[esi+loader_par3_ok_params], ecx
setup_common:
	add	edx, [outsize]
	add	[esi-8], edx
	add	[esi-4], edx
	push	edi
	mov	ecx, [cur_loader_size]
	add	edi, [outsize]
	add	edi, 24h
	mov	esi, offset cur_loader
	rep	movsb
	pop	edi
	mov	eax, [edi+16]
	mov	ecx, 100
	mul	ecx
	div	[insize]
	aam
	xchg	al, ah
	add	ax, '00'
	mov	[ratio], ax
	mov	esi, offset done_str
	push	done_len
	pop	ecx
	call	write_string
; save output file
	mov	esi, offset outname
	call	get_full_name
	mov	ebx, offset fn58block
	mov	byte ptr [ebx], 1
	mov	eax, [outfile]
	mov	ecx, [eax+16]
	mov	[ebx+8], ecx
	mov	[ebx+12], eax
	push	58
	pop	eax
	int	40h
	test	eax, eax
	jz	short @f
outerr:
	mov	esi, offset outfileerr_str
	push	outfileerr_len
	pop	ecx
	jmp	write_string
@@:
	ret

set_cur_loader:
; in: esi->loader info
	lodsd
	mov	edi, offset cur_loader_size
	stosd
	xchg	eax, ecx
	movsd
	lodsd
	xchg	eax, esi
	rep	movsb
	ret

pack_calltrick_fail:
	xor	eax, eax
	ret
pack_calltrick:
; input preprocessing
	xor	eax, eax
	mov	edi, offset ct1
	mov	ecx, 256/4
	push	edi
	rep	stosd
	pop	edi
	mov	ecx, [insize]
	mov	esi, [infile]
	cmp	ecx, 1000000h
	xchg	eax, edx
	jae	short pack_calltrick_fail
	mov	ebx, [inbuftmp]
input_pre:
	lodsb
	sub	al, 0E8h
	cmp	al, 1
	ja	short input_pre_cont
	cmp	ecx, 5
	jb	short input_pre_done
	lodsd
	add	eax, esi
	sub	eax, [infile]
	cmp	eax, [insize]
	jae	short xxx
	sub	ecx, 4
	shl	eax, 8
	mov	[esi-4], eax
	inc	edx
	mov	[ebx], esi
	add	ebx, 4
	jmp	short input_pre_cont
xxx:	sub	esi, 4
	movzx	eax, byte ptr [esi]
	mov	byte ptr [eax+edi], 1
input_pre_cont:
	loop	input_pre
input_pre_done:
	mov	[ctn], edx
	xor	eax, eax
	mov	ecx, 256
	repnz	scasb
	jnz	pack_calltrick_fail
	not	cl
	mov	[cti], cl
@@:
	cmp	ebx, [inbuftmp]
	jz	@f
	sub	ebx, 4
	mov	eax, [ebx]
	mov	[eax-4], cl
	jmp	@b
@@:

pack_normal:
	push	0
	push	[workmem]
	mov	eax, [insize]
	sub	eax, [indelta]
	push	eax
	mov	eax, [outfile]
	add	eax, 24h
	push	eax
	mov	eax, [infile]
	add	eax, [indelta]
	push	eax
	call	_aP_pack
	add	esp, 20
	ret

get_full_name:
	push	esi
	mov	esi, offset path
	mov	ecx, [esi-4]
	mov	edi, offset fullname
	rep	movsb
	mov	al, '/'
	cmp	byte ptr [edi-1], al
	jz	short @f
	stosb
@@:	pop	esi
	cmp	byte ptr [esi], al
	jnz	short @f
	mov	edi, offset fullname
@@:	mov	ecx, [esi-4]
	rep	movsb
	xor	eax, eax
	stosb
	ret

redraw_bForceMemInc:
	cmp	[bForceMemInc], 0
	jnz	short draw_bForceMemInc_true
	push	8
	pop	eax
	mov	edx, 80000006h
	int	40h
	mov	al, 8
	mov	esi, [color_table+36]
	mov	ebx, 8000Ah
	mov	ecx, [skinheight]
	shl	ecx, 16
	add	ecx, 0Ah+280000h
	push	6
	pop	edx
	int	40h
	ret

draw_bForceMemInc_true:
	push	38
	pop	eax
	mov	ebx, 0B0010h
	mov	ecx, [skinheight]
	shl	ecx, 16
	mov	cx, word ptr [skinheight]
	add	ecx, 2A002Fh
	mov	edx, [color_table+28]
	int	40h
	rol	ecx, 16
	int	40h
	ret

write_string:
; in: esi=pointer, ecx=length
	mov	edx, [message_cur_pos]
x1:
	lea	edi, [message_mem+edx]
do_write_char:
	lodsb
	cmp	al, 10
	jz	short newline
	stosb
	inc	edx
	loop	do_write_char
	jmp	short x2
newline:
	xor	eax, eax
	stosb
	mov	eax, edx
	and	eax, 63
	add	edx, 64
	sub	edx, eax
	loop	x1
x2:	mov	[message_cur_pos], edx
; update window
	push	13
	pop	eax
	mov	ebx, 90141h
	mov	ecx, [skinheight]
	shl	ecx, 16
	add	ecx, 3700DEh
	mov	edx, [color_table+20]
	int	40h
draw_messages:
	mov	ebx, [skinheight]
	add	ebx, 3Ch+12*10000h
	mov	edi, offset message_mem
@@:	push	edi
	xor	eax, eax
	push	64
	pop	ecx
	repnz	scasb
	sub	ecx, 63
	neg	ecx
	mov	esi, ecx
	mov	al, 4
	pop	edi
	mov	edx, edi
	mov	ecx, [color_table+32]
	int	40h
	add	ebx, 10
	add	edi, 64
	cmp	edi, offset message_cur_pos
	jb	short @b
	ret

draw_window:
; start redraw
	push	12
	pop	eax
	xor	ebx, ebx
	inc	ebx
	int	40h
	mov	edi, [skinheight]
; define window
	xor	eax, eax
	mov	ebx, 640153h
	mov	ecx, 64011Eh
	add	ecx, edi
	mov	edx, [color_table+20]
	add	edx, 03000000h
	int	40h
; caption
	mov	ebx, 80008h
	mov	al, 4
	mov	ecx, [color_table+16]
	mov	edx, offset caption_str
	push	caption_len
	pop	esi
	int	40h
; lines - horizontal
	mov	edx, [color_table+36]
	mov	ebx, 80100h
	mov	ecx, edi
	shl	ecx, 16
	or	ecx, edi
	add	ecx, 20002h
	mov	al, 38
	int	40h
	add	ecx, 0C000Ch
	int	40h
	add	ecx, 0C000Ch
	int	40h
	add	ecx, 0C000Ch
	int	40h
; lines - vertical
	mov	ebx, 80008h
	sub	ecx, 240000h
	int	40h
	add	ebx, 340034h
	int	40h
	add	ebx, 0C400C4h
	int	40h
; draw frame for messages data
	push	ecx
	mov	ebx, 8014Ah
	add	ecx, 340010h
	int	40h
	add	ecx, 0E0h*10001h
	int	40h
	mov	ebx, 80008h
	sub	cx, 0E0h
	int	40h
	mov	ebx, 14A014Ah
	int	40h
	pop	ecx
; define start button
	mov	al, 8
	mov	cx, 24h
	mov	ebx, 1020048h
	push	2
	pop	edx
	mov	esi, [color_table+36]
	int	40h
; bForceMemInc button
	mov	ebx, 8000Ah
	add	ecx, -24h+0Ah+260000h
	push	ecx
	mov	dl, 6
	int	40h
	push	eax
	cmp	[bForceMemInc], 0
	jz	short @f
	call	draw_bForceMemInc_true
@@:
	push	esi
	lea	ebx, [edi+2Bh+180000h]
	mov	ecx, [color_table+32]
	mov	edx, offset bForceMemIncButton_str
	mov	esi, bForceMemIncButton_len
	mov	al, 4
	int	40h
	pop	esi
	pop	eax
	pop	ecx
; question button
	push	esi
	mov	ebx, 1410009h
	push	7
	pop	edx
	int	40h
	mov	al, 4
	mov	edx, offset aQuestion
	push	1
	pop	esi
	shr	ecx, 16
	lea	ebx, [ecx+1440002h]
	mov	ecx, [color_table+28]
	int	40h
	mov	al, 8
	pop	esi
; define settings buttons
	mov	ebx, 90032h
	lea	ecx, [edi+2]
	shl	ecx, 16
	mov	cx, 0Bh
	push	3
	pop	edx
@@:
	int	40h
	add	ecx, 0C0000h
	inc	edx
	cmp	edx, 5
	jbe	@b
; text on settings buttons
	lea	ebx, [edi+5+0C0000h]
	mov	al, 4
	mov	ecx, [color_table+28]
	push	offset buttons1names
	pop	edx
	push	8
	pop	esi
@@:
	int	40h
	add	edx, esi
	add	ebx, 0Ch
	cmp	byte ptr [edx-6], ' '
	jnz	@b
; text on start button
	lea	ebx, [edi+10h+1180000h]
	push	offset aStart
	pop	edx
	push	aStart_len
	pop	esi
	int	40h
; infile, outfile, path strings
	mov	edx, offset inname
	lea	ebx, [edi+400005h]
editdraw:
	mov	esi, [edx-4]
	mov	al, 4
	mov	ecx, [color_table+32]
	int	40h
	cmp	edx, [curedit]
	jnz	short cont
	mov	al, 1
	push	ebx
	push	edx
	movzx	ecx, bx
	shr	ebx, 16
	lea	edx, [esi*2]
	lea	edx, [edx+edx*2]
	lea	ebx, [ebx+edx+2]
	add	ecx, 4
	xor	edx, edx
@@:
	cmp	esi, 32
	jz	@f
	int	40h
	add	ebx, 6
	inc	esi
	jmp	@b
@@:
	pop	edx
	pop	ebx
cont:
	add	edx, 36
	add	ebx, 0Ch
	cmp	edx, offset path+36
	jb	editdraw
; draw messages
	call	draw_messages
; end redraw
	push	12
	pop	eax
	push	2
	pop	ebx
	int	40h
	ret
aQuestion db '?'

copy_name:
	lea	edx, [edi+32]
@@:	lodsb
	cmp	al, ' '
	jbe	short copy_name_done
	stosb
	cmp	edi, edx
	jb	short @b
@@:	lodsb
	cmp	al, ' '
	ja	short @b
copy_name_done:
	dec	esi
	sub	edx, 32
	sub	edi, edx
	mov	[edx-4], edi

skip_spaces:
	lodsb
	cmp	al, 0
	jz	short @f
	cmp	al, ' '
	jbe	short skip_spaces
@@:	dec	esi
	ret

clear_edit_points:
; clear edit points (if is)
	mov	esi, [curedit]
	test	esi, esi
	jz	short cleared_edit_points
	push	eax
	mov	al, 13
	mov	ebx, [esi-4]
	imul	ebx, 6
	mov	edi, ebx
	add	ebx, 40h
	shl	ebx, 16
	add	ebx, 32*6
	sub	bx, di
	mov	ecx, [curedit_y]
	shl	ecx, 16
	or	cx, 9
	mov	edx, [color_table+20]
	int	40h
	pop	eax
cleared_edit_points:
	ret

	end	_start
